
;// SMBIOS.inc
;// Created by "Marylin" 18.01.2021
;// Types: 0,1,2,3,4,5,6,7,8,9,11,13,16,17,19,20,22
;//------------------------------------------------

struct RawSMBIOSData
 Method     db  0
 MjVer      db  0
 MnVer      db  0
 DmiRev     db  0
 Length     dd  0
ends

struct HEADER
 Type       db  0
 Length     db  0
 Handle     dw  0
ends

struct  TYPE0   ;//<---------------- BIOS-info
 Header           HEADER
 Reserved0        rb  2
 SegAddr          dw  0
 Reserved1        rb  1
 RomSize          db  0
 BiosType         dq  0
 Ext1             db  0
 Ext2             db  0
 MajorRelease     db  0
 MinorRelease     db  0
 ECrelease        dw  0
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE1   ;//<---------------- SYSTEM-info
 Header           HEADER
 Reserved0        rb  4
 UUID             rb  16     ;//   
 WakeUpType       db  0
 Reserved1        rb  2
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE2   ;//<---------------- BASE.BOARD-info
 Header           HEADER
 Reserved0        rb  5
 FeatureFlags     db  0
 Reserved1        rb  1
 ChassisHandle    dw  0
 BoardType        db  0
 NumObjHandle     db  0
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE3   ;//<---------------- CHASSIS-info
 Header           HEADER
 Reserved0        rb  1
 ChassisType      db  0
 Reserved1        rb  3
 Bootup           db  0
 PowerSupply      db  0
 Thermal          db  0
 Security         db  0
 OEMDefine        dd  0
 Height           db  0
 NumPowerCord     db  0
 ElementCount     db  0
 ElementLength    db  0
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE4   ;//<---------------- PROCESSOR-info
 Header           HEADER
 Reserved0        rb  1
 CpuType          db  0
 CpuFamily        db  0
 Reserved1        rb  1
 CpuID            dq  0
 Reserved2        rb  1
 CpuVoltage       db  0
 ExtClock         dw  0
 MaxSpeed         dw  0
 CurrentSpeed     dw  0
 CpuStatus        db  0
 CpuUpgrade       db  0      ;//   : 15h = LGA775
 L1cache          dw  0
 L2cache          dw  0
 L3cache          dw  0
 Reserved3        rb  3
 CoreCount        db  0
 CoreEnabled      db  0
 ThreadCount      db  0
 Characteristics  dw  0
 Family2          dw  0
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE5   ;//<---------------- MEM.CONTROLLER-info
 Header           HEADER
 EccMethod        db  0
 EccCapability    db  0
 SuppInterleave   db  0
 CurrInterleave   db  0
 MaxModuleSize    db  0
 SuppSpeed        dw  0
 SuppType         dw  0
 ModuleVoltage    db  0
 Slots            db  0
 Slots1           dw  0
 Slots2           dw  0
 Slots3           dw  0
 Slots4           dw  0
 EccEnabled       db  0
 Terminal         dw  0
ends

struct  TYPE6   ;//<---------------- MEM.MODULE-info
 Header           HEADER
 Reserved0        rb  1
 BankCount        db  0
 CurrentSpeed     db  0
 MemoryType       dw  0
 InstalledSize    db  0
 EnabledSize      db  0
 ErrorStatus      db  0
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE7   ;//<---------------- CACHE-info
 Header           HEADER
 Reserved0        rb  1
 CacheConfig      dw  0
 CacheMaxSize     dw  0
 CacheInstSize    dw  0
 SramType         dw  0
 CacheSpeed       db  0
 EccType          db  0
 CacheType        db  0
 Associativity    db  0
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE8   ;//<---------------- PORT-info
 Header           HEADER
 Reserved0        rb  3
 ExtConnType      db  0
 PortType         db  0
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE9   ;//<---------------- SYSTEM.SLOT-info
 Header           HEADER
 Reserved0        rb  1
 SlotType         db  0
 BusWidth         db  0
 Usage            db  0
 Length           db  0
 ID               dw  0
 Characteristic1  db  0
 Characteristic2  db  0
 SegmentGroup     dw  0
 BusNumber        db  0
 FuncNumber       db  0
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE11   ;//<---------------- OEM.STRING-info
 Header           HEADER
 Count            db  0
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE13   ;//<---------------- BIOS.LANGUAGE-info
 Header           HEADER
 InstLang         db  0
 Flags            db  0
 Reserved         rb  16
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE16   ;//<---------------- MEM.ARRAY-info
 Header           HEADER
 Reserved         rb  3
 MaxCapacity      dd  0      ;// x1024
 ErrorHndl        dw  0
 NumberOfDev      dw  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE17   ;//<---------------- MEM.DEVICE-info
 Header           HEADER
 ArrayHndl        dw  0
 ErrorHndl        dw  0
 TotalWidth       dw  0
 DataWidth        dw  0
 Size             dw  0
 FormFactor       db  0
 DeviceSet        db  0
 Reserved0        rb  2
 MemoryType       db  0
 TypeDetail       dw  0
 MemSpeed         dw  0
 Reserved1        rb  5
 String           db  ?      ;// 
 Terminal         dw  0
ends

struct  TYPE19   ;//<---------------- MEM.ARRAY.MAPPED.ADDRESS-info
 Header           HEADER
 StartAddress     dd  0
 EndAddress       dd  0
 ArrayHndl        dw  0
 PartWidth        db  0
 Terminal         dw  0
ends

struct  TYPE20   ;//<---------------- MEM.DEVICE.MAPPED.ADDRESS-info
 Header           HEADER
 StartAddress     dd  0
 EndAddress       dd  0
 DeviceHndl       dw  0
 AddressHndl      dw  0
 PartRowPoss      db  0
 InterleavePoss   db  0
 InterleaveDepth  db  0
 Terminal         dw  0
ends

struct  TYPE22   ;//<---------------- PORTABLE.BATTERY-info
 Header           HEADER
 Reserved0        rb  5
 Chemistry        db  0
 Capacity         dw  0
 Voltage          dw  0
 SBDSVersion      db  0
 MaxError         db  0
 SBDSSerial       dw  0
 SBDSDate         dw  0
 Reserved1        rb  6
 String           db  ?      ;// 
 Terminal         dw  0
ends

